#!/usr/bin/env perl
use strict;
use warnings;
use feature 'say';

use Encode;
use JSON;
use Pithub;
use Time::Piece;
use Time::Seconds;

my $now = localtime;
# Time::Pieceオブジェクトで前日
my $yesterday = $now - ONE_DAY;

my $pit = Pithub->new(
    token => 'my_oauth_token',
);

my $res = $pit->repos->pull_requests->list(
    user  => 'XXXXX',
    repo  => 'YYYYY',
    params => {
        state  => 'open',
    }
)->response;

my $json = decode_json($res->content);
for my $rec (@{$json}) {
    my $updated_at = Time::Piece->strptime(
        $rec->{updated_at}, '%Y-%m-%dT%H:%M:%SZ'
    );
    # Pull Requestの更新後1日以上経過している場合
    if ($updated_at < $yesterday) {
        printf("[%s] が長時間確認されていません。 %s\n",
               encode_utf8($rec->{title}),
               $rec->{html_url});
    }
}
